• HDU 1963 Investment (完全背包)


                                                             Investment

                                                 Time Limit: 5000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)
                                                             Total Submission(s): 491    Accepted Submission(s): 205


    Problem Description
    John never knew he had a grand-uncle, until he received the notary’s letter. He learned that his late grand-uncle had gathered a lot of money, somewhere in South-America, and that John was the only inheritor.

    John did not need that much money for the moment. But he realized that it would be a good idea to store this capital in a safe place, and have it grow until he decided to retire. The bank convinced him that a certain kind of bond was interesting for him.

    This kind of bond has a fixed value, and gives a fixed amount of yearly interest, payed to the owner at the end of each year. The bond has no fixed term. Bonds are available in different sizes. The larger ones usually give a better interest. Soon John realized that the optimal set of bonds to buy was not trivial to figure out. Moreover, after a few years his capital would have grown, and the schedule had to be re-evaluated.

    Assume the following bonds are available:
    Value Annual interest
    4000   400
    3000   250

    With a capital of $10 000 one could buy two bonds of $4 000, giving a yearly interest of $800. Buying two bonds of $3 000, and one of $4 000 is a better idea, as it gives a yearly interest of $900. After two years the capital has grown to $11 800, and it makes sense to sell a $3 000 one and buy a $4 000 one, so the annual interest grows to $1 050. This is where this story grows unlikely: the bank does not charge for buying and selling bonds. Next year the total sum is $12 850, which allows for three times $4 000, giving a yearly interest of $1 200.

    Here is your problem: given an amount to begin with, a number of years, and a set of bonds with their values and interests, find out how big the amount may grow in the given period, using the best schedule for buying and selling bonds.
     

    Input
    The first line contains a single positive integer N which is the number of test cases. The test cases follow.

    The first line of a test case contains two positive integers: the amount to start with (at most $1 000 000), and the number of years the capital may grow (at most 40).

    The following line contains a single number: the number d (1 <= d <= 10) of available bonds.

    The next d lines each contain the description of a bond. The description of a bond consists of two positive integers: the value of the bond, and the yearly interest for that bond. The value of a bond is always a multiple of $1 000. The interest of a bond is never more than 10% of its value.
     

    Output
    For each test case, output – on a separate line – the capital at the end of the period, after an optimal schedule of buying and selling.
     

    Sample Input
    1 10000 4 2 4000 400 3000 250
     

    Sample Output
    14050

    题意: 买证券 

                    T 组案例;

                   输入本金s, 再输入要买几年的证券

                   再输入有哪几种证券,

                  买每种证券需要多少的金额,还有每种证券的年利率。

    让你求4年后,John  ”最多 “将有多少钱。

    明显是一个完全背包问题,这一年买证券赚的钱+本金 作为 下一年买证券的本金,不过应该注意的是,由于本金比较大,直接开一个10的6次方的数组,不RE的,肯定会超内存,所以需要优化一下,因为题目中说了,每种证券的金额都是1000的倍数,所以这里我可以把本题中的 w[ i ], 除以1000, 而本金则也可以除以1000,但是应该注意c此处  和。同学可以自己体会一下为什么这样做。

    #include<stdio.h>
    #include<string.h>
    #include<stdlib.h>
    
    int max(int a, int b)
    {
        return a>b?a:b;
    }
    
    int main()
    {
        int T, v, year, n, i, j, k, t;
        int *dp, w[110], c[110];
    
        scanf("%d", &T);
        while(T--)
        {
            scanf("%d %d", &v, &year);
            scanf("%d", &n);
    
            memset(w, 0, sizeof(w));
            memset(c, 0, sizeof(c));
    
            for(i=0; i<n; i++)
                scanf("%d %d", &w[i], &c[i]);
    
         for(i=0; i<n; i++)
         {
             w[i] = w[i]/1000;
         }
          for(k=0; k<year; k++)
           {
                 t = v;
                 v = v / 1000;
             dp = (int *)malloc((v+1)*sizeof(int));
    
             for(i=0; i<=v; i++)
               dp[i] = 0;
    
            for(i=0; i<n; i++)
               for(j=w[i]; j<=v; j++)
               {
                   dp[j] = max(dp[j], dp[j-w[i]]+c[i]);
               }
               v = t+dp[v];
           }
           printf("%d
    ", v);
        }
        return 0;
    }
    


    每天训练发现我比别人做的好慢,但是理解的更深刻,如果一开始学一个新知识点就搜模板,那么这样的人是走不远的,毕业之后带走的只有思维,什么荣誉,奖杯都已经不重要了。
  • 相关阅读:
    调用 验证码
    始终居中的弹出层
    jq常用
    ThinkPHP redirect 方法
    session 的生成和删除
    1355:字符串匹配问题(strs)
    1348:【例49】城市公交网建设问题
    1357:车厢调度(train)
    1358:中缀表达式值(expr)
    1351:【例412】家谱树
  • 原文地址:https://www.cnblogs.com/6bing/p/3931300.html
Copyright © 2020-2023  润新知